//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrOrange
#property indicator_width1  2

//
//
//
//
//

extern int            KPeriod                    = 14;
extern int            Slowing                    = 15;
extern int            DPeriod                    = 15;
extern ENUM_STO_PRICE Price                      = PRICE_CLOSE;
extern double         levelOb                    = 80;
extern double         levelOs                    = 20;

extern bool           arrowsVisible              = true;
extern string         arrowsIdentifier           = "nlsto arrows1";
extern double         arrowsUpperGap             = 1.0;
extern double         arrowsLowerGap             = 1.0;

extern bool           arrowsOnSignalCross        = true;
extern color          arrowsOnSignalCrossUpColor = clrLimeGreen;
extern color          arrowsOnSignalCrossDnColor = clrRed;
extern int            arrowsOnSignalCrossUpCode  = 241;
extern int            arrowsOnSignalCrossDnCode  = 242;
extern int            arrowsOnSignalCrossUpSize  = 2;
extern int            arrowsOnSignalCrossDnSize  = 2;

extern bool           arrowsOnObosCross          = true;
extern color          arrowsOnObosCrossUpColor   = clrLimeGreen;
extern color          arrowsOnObosCrossDnColor   = clrRed;
extern int            arrowsOnObosCrossUpCode    = 241;
extern int            arrowsOnObosCrossDnCode    = 242;
extern int            arrowsOnObosCrossUpSize    = 1;
extern int            arrowsOnObosCrossDnSize    = 1;

//
//
//
//
//

double StochBuffer[];
double SignalBuffer[];
double alphaStoch[];
double alphaSignal[];
double pricesStoch[];
double pricesSignal[];
double cross[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,StochBuffer);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexBuffer(2,cross);
   SetIndexBuffer(3,trend);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
      Slowing = MathMax(Slowing,1);
   IndicatorShortName("NonLag stochastic ("+KPeriod+","+DPeriod+","+Slowing+")");
   return(0);
}
int deinit()
{
   deleteArrows();
return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(pricesStoch,0) != Bars) { ArrayResize(pricesStoch,Bars); ArrayResize(pricesSignal,Bars);}

   //
   //
   //
   //
   //
   
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      pricesStoch[r] = iStochastic(NULL,0,KPeriod,1,1,MODE_SMA,Price,MODE_MAIN,i);
      StochBuffer[i] = iNoLagMa(alphaStoch,pricesStoch,1,Slowing,i,r);
      if (DPeriod>1)
      {
         pricesSignal[r] = StochBuffer[i];
         SignalBuffer[i] = iNoLagMa(alphaSignal,pricesSignal,2,DPeriod,i,r);
      } 
        cross[i] = cross[i+1];
        trend[i] = 0;
           if (StochBuffer[i]>SignalBuffer[i]) cross[i] = 1;
           if (StochBuffer[i]<SignalBuffer[i]) cross[i] =-1;
           if (StochBuffer[i]>levelOb)         trend[i] = 1;
           if (StochBuffer[i]<levelOs)         trend[i] =-1;  
        
        
        if (arrowsVisible)
        {
           ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
           ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
           string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
           if (arrowsOnSignalCross && cross[i] != cross[i+1])
           {
              if (cross[i] == 1) drawArrow("1",0.5,i,arrowsOnSignalCrossUpColor,arrowsOnSignalCrossUpCode,arrowsOnSignalCrossUpSize,false);
              if (cross[i] ==-1) drawArrow("1",0.5,i,arrowsOnSignalCrossDnColor,arrowsOnSignalCrossDnCode,arrowsOnSignalCrossDnSize,true);
           }
           if (arrowsOnObosCross && trend[i] != trend[i+1])
           {
             if (trend[i+1] ==  1 && trend[i] != 1) drawArrow("2",1,i,arrowsOnObosCrossDnColor,arrowsOnObosCrossDnCode,arrowsOnObosCrossDnSize,true);
             if (trend[i+1] == -1 && trend[i] !=-1) drawArrow("2",1,i,arrowsOnObosCrossUpColor,arrowsOnObosCrossUpCode,arrowsOnObosCrossUpSize,false);
              
           }
              
         }       
   }
	return(0);	
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define Pi 3.1415926535

//
//
//
//
//

double values[][3];
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double &alpha[], double &price[], int forvalue, int length, int i, int r)
{
   int forValue = forvalue-1;
   if (length<3) return(price[r]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alpha,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alpha[k]                   = g * beta;
            values[forValue][_weight] += alpha[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alpha[k]*price[r-k];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode, int theSize,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}
